/* ---------------------------------------------------------------------
 * day_of_year converts a year/month/day triple into the day of year,
 * starting with 0 (1.1.) and ending at 364 or 365 (leap)
 * coding after Kernighan/Ritchie :-)
 * compile with
 *      cc -s -o day_of_year day_of_year.c
 * ---------------------------------------------------------------------
 * This file is a part of tcharge, version 1.3, 11MAY98
 * Copyright (C) 1997,98 Volker B"orchers (boercher@physik.uni-bremen.de)
 * See file `tcharge.c' for legal affairs.
 */

#include <stdio.h>
#include <stdlib.h>


#define USE "Usage: day_of_year <year> <month> <day>\nExample: day_of_year 1997 2 25\n"

int main(int argc, char *argv[])
{
  char **check=NULL;
  int i, date[3], leap;
  int day_tab[2][13] = {
    {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},
    {0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31}
  };

  if(argc != 4) {
    fprintf(stderr, "(Stop) Wrong number of arguments.\n%s", USE);
    return 1;
  }
  for(i=0; i<3; i++) {
    date[i] = (int) strtoul(argv[i+1], check, 10);
    if (check != NULL) {
      fprintf(stderr, "(Stop) Cannot convert string \"%s\" to integer.\n%s",
	      argv[i+1], USE);
      return 1;
    }
  }
  if(date[0] < 100) {
    fprintf(stderr, "(Stop) Year (here %i) must be fully specified (1997 not 97)!\n%s",
	    date[0], USE);
    return 1;
  }
  leap = ((date[0]) % 4 == 0 && ((date[0]) % 100 != 0 || (date[0]) % 400 == 0));
  for(i=1; i<date[1]; i++)
    date[2] += day_tab[leap][i];
  printf("yearday = %i\n", date[2] - 1);

  return 0;
}
